// HelloDX11.cpp : AvP[ṼGg |Cg`܂B
//

#include <Windows.h>
#include <tchar.h>
#include <D3D11.h>
#include <directxmath.h>
#include <stdio.h>

#define MAX_LOADSTRING 100

#pragma comment( lib, "d3d11.lib" )

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING] = _T("SampleMSAA11");					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING] = _T("SampleMSAA11");			// C EBhE NX
HWND	g_hWindow;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

using namespace DirectX;

struct VertexPC {
	XMFLOAT3	Pos;
	DWORD		Color;
};
struct VertexPT {
	XMFLOAT3	Pos;
	XMFLOAT2	Tex;
};

struct D3DResources {
	ID3D11InputLayout*  pInput;
	ID3D11VertexShader* pVS;
	ID3D11PixelShader*  pPS;
	ID3D11Buffer*  pVB;

	D3D11_VIEWPORT vp;
	ID3D11RenderTargetView* pRTV;
	ID3D11DepthStencilView* pDSV;

	ID3D11ShaderResourceView* pTexture;
};
D3DResources g_Resource[2];


bool loadShaderBin( const char* fileName, void** pBinary, int* size ) {
	FILE* fp;
	fopen_s( &fp, fileName, "rb" );
	if( fp == NULL ) {
		return false;
	}

	fseek( fp, 0, SEEK_END );
	int   nSize = (int)ftell( fp );
	char* pBuffer = (char*)malloc( nSize );
	rewind( fp );
	fread( pBuffer, 1, nSize, fp );
	fclose( fp );
	fp = 0;

	*pBinary = pBuffer;
	*size = nSize;

	return true;
}

// vC}ɕ`悷邽߂̃\[X𐶐.
void createResourcePrimaryDraw( ID3D11Device* pd3dDevice ) {
	// r[|[gݒ.
	D3D11_VIEWPORT* vp = &(g_Resource[0].vp);
	vp->TopLeftX = 0;
	vp->TopLeftY = 0;
	vp->Width = 640;
	vp->Height = 480;
	vp->MinDepth = 0.0f;
	vp->MaxDepth = 1.0f;

	void* pShaderBinary = NULL;
	int   nSize = 0;
	HRESULT hr;

	loadShaderBin( "ps_tex.cso", &pShaderBinary, &nSize );
	hr = pd3dDevice->CreatePixelShader( pShaderBinary, nSize, NULL, &(g_Resource[0].pPS) );
	free( pShaderBinary );
	loadShaderBin( "vs_tex.cso", &pShaderBinary, &nSize );
	hr = pd3dDevice->CreateVertexShader( pShaderBinary, nSize, NULL, &(g_Resource[0].pVS) );

	// _͂̐ݒ.
	D3D11_INPUT_ELEMENT_DESC layout1[] = {
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
	};
	pd3dDevice->CreateInputLayout( layout1, 2, pShaderBinary, nSize, &(g_Resource[0].pInput) );
	free( pShaderBinary );

	// _obt@̏
	D3D11_BUFFER_DESC descVB;
	ZeroMemory( &descVB, sizeof(descVB) );
	descVB.Usage = D3D11_USAGE_DEFAULT;
	descVB.ByteWidth = sizeof(VertexPT) * 4;
	descVB.BindFlags = D3D11_BIND_VERTEX_BUFFER;

	/// _""f[^.
	VertexPT vbdata[] = {
		{ XMFLOAT3( -128.0f, 128.0f, 0.0f ), XMFLOAT2(0.0f, 0.0f) },
		{ XMFLOAT3(  128.0f, 128.0f, 0.0f ), XMFLOAT2(1.0f, 0.0f) },
		{ XMFLOAT3( -128.0f,-128.0f, 0.0f ), XMFLOAT2(0.0f, 1.0f) },
		{ XMFLOAT3(  128.0f,-128.0f, 0.0f ), XMFLOAT2(1.0f, 1.0f) },
	};
	D3D11_SUBRESOURCE_DATA subresData;
	ZeroMemory( &subresData, sizeof(subresData) );
	subresData.pSysMem = vbdata;

	pd3dDevice->CreateBuffer( &descVB, &subresData, &(g_Resource[0].pVB) );
}

// eNX`ɕ`悷邽߂̃\[X𐶐.
void createResourceRenderTargetDraw( ID3D11Device* pd3dDevice ) {
	// r[|[gݒ.
	D3D11_VIEWPORT* vp = &(g_Resource[1].vp);
	vp->TopLeftX = 0;
	vp->TopLeftY = 0;
	vp->Width = 256;
	vp->Height = 256;
	vp->MinDepth = 0.0f;
	vp->MaxDepth = 1.0f;

	void* pShaderBinary = NULL;
	int   nSize = 0;
	HRESULT hr;

	loadShaderBin( "ps.cso", &pShaderBinary, &nSize );
	hr = pd3dDevice->CreatePixelShader( pShaderBinary, nSize, NULL, &(g_Resource[1].pPS) );
	free( pShaderBinary );
	loadShaderBin( "vs.cso", &pShaderBinary, &nSize );
	hr = pd3dDevice->CreateVertexShader( pShaderBinary, nSize, NULL, &(g_Resource[1].pVS) );

	// _͂̐ݒ.
	D3D11_INPUT_ELEMENT_DESC layout[] = {
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D11_INPUT_PER_VERTEX_DATA, 0 },
		{ "COLOR", 0, DXGI_FORMAT_R8G8B8A8_UNORM, 0, 12, D3D11_INPUT_PER_VERTEX_DATA, 0 },
	};
	pd3dDevice->CreateInputLayout( layout, 2, pShaderBinary, nSize, &(g_Resource[1].pInput) );
	free( pShaderBinary );

	// _obt@̏
	D3D11_BUFFER_DESC descVB;
	ZeroMemory( &descVB, sizeof(descVB) );
	descVB.Usage = D3D11_USAGE_DEFAULT;
	descVB.ByteWidth = sizeof(VertexPC) * 4;
	descVB.BindFlags = D3D11_BIND_VERTEX_BUFFER;

	/// _""f[^.
	VertexPC vbdata[] = {
		{ XMFLOAT3(-1.0f, 1.0f, 0.0f ), 0xFFFFFFFF },
		{ XMFLOAT3( 1.0f, 1.0f, 0.0f ), 0xFFFF00FF },
		{ XMFLOAT3( 0.0f,-1.0f, 0.0f ), 0xFF00FF00 },
		{ XMFLOAT3( 0.5f,-0.5f, 0.0f ), 0xFF0000FF },
	};
	D3D11_SUBRESOURCE_DATA subresData;
	ZeroMemory( &subresData, sizeof(subresData) );
	subresData.pSysMem = vbdata;

	pd3dDevice->CreateBuffer( &descVB, &subresData, &(g_Resource[1].pVB) );
}
void deleteResource() {
	for( int i = 0; i < 2; ++i ) {
		D3DResources* p = &g_Resource[i];
		if( p->pInput ) { p->pInput->Release();p->pInput=0; }
		if( p->pVS ) { p->pVS->Release();p->pVS = 0; }
		if( p->pPS ) { p->pPS->Release();p->pPS = 0; }
		if( p->pVB ) { p->pVB->Release();p->pVB = 0; }
		if( p->pRTV ) { p->pRTV->Release(); p->pRTV = 0; }
		if( p->pDSV ) { p->pDSV->Release(); p->pDSV = 0; }
		if( p->pTexture ) { p->pTexture->Release(); p->pTexture=0; }
	}
}

void drawToPrimary( ID3D11DeviceContext* pContext, ID3D11ShaderResourceView* pRenderTextureSRV ) {
	ID3D11ShaderResourceView* dummy[] = { NULL };
	pContext->PSSetShaderResources( 0, 1, dummy );

	pContext->RSSetViewports( 1, &(g_Resource[0].vp) );
	pContext->OMSetRenderTargets( 1, &(g_Resource[0].pRTV), g_Resource[0].pDSV );

	// ʂ̃NA
	float  clearColor[4] = { 0.0f, 0.0f, 0.25f, 0.0f };
	pContext->ClearRenderTargetView( g_Resource[0].pRTV, clearColor );
	pContext->ClearDepthStencilView( g_Resource[0].pDSV, D3D11_CLEAR_DEPTH | D3D11_CLEAR_STENCIL, 1.0f, 0 );

	// obt@̃Zbg.
	UINT strides[] = { sizeof(VertexPT) };
	UINT offsets[] = { 0 };
	pContext->IASetInputLayout( g_Resource[0].pInput );
	pContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP );
	pContext->IASetVertexBuffers( 0, 1, &(g_Resource[0].pVB), strides, offsets );

	// VF[_[̃Zbg.
	pContext->VSSetShader( g_Resource[0].pVS, NULL, 0 );
	pContext->PSSetShader( g_Resource[0].pPS, NULL, 0 );
	pContext->PSSetShaderResources( 0, 1, &pRenderTextureSRV );

	pContext->Draw( 4, 0 );
}

void drawToTexture( ID3D11DeviceContext* pContext ) {
	ID3D11ShaderResourceView* dummy[] = { NULL };
	pContext->PSSetShaderResources( 0, 1, dummy );

	pContext->RSSetViewports( 1, &(g_Resource[1].vp) );
	pContext->OMSetRenderTargets( 1, &(g_Resource[1].pRTV), g_Resource[1].pDSV );

	// ʂ̃NA
	float  clearColor[4] = { 0.25f, 0.25f, 0.25f, 0.0f };
	pContext->ClearRenderTargetView( g_Resource[1].pRTV, clearColor );
	pContext->ClearDepthStencilView( g_Resource[1].pDSV, D3D11_CLEAR_DEPTH | D3D11_CLEAR_STENCIL, 1.0f, 0 );

	// obt@̃Zbg.
	UINT strides[] = { sizeof(VertexPC) };
	UINT offsets[] = { 0 };
	pContext->IASetInputLayout( g_Resource[1].pInput );
	pContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP );
	pContext->IASetVertexBuffers( 0, 1, &(g_Resource[1].pVB), strides, offsets );

	// VF[_[̃Zbg.
	pContext->VSSetShader( g_Resource[1].pVS, NULL, 0 );
	pContext->PSSetShader( g_Resource[1].pPS, NULL, 0 );

	pContext->Draw( 3, 0 );

}


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	ZeroMemory( &msg, sizeof(msg) );

	// O[oĂ܂B
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	// DirectX
	// Xbv`FC̐ݒ
	DXGI_SWAP_CHAIN_DESC sd;
	ZeroMemory( &sd, sizeof(sd) );
	sd.BufferCount = 1;
	sd.BufferDesc.Width = 640;
	sd.BufferDesc.Height = 480;
	sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	sd.BufferDesc.RefreshRate.Numerator = 60;
	sd.BufferDesc.RefreshRate.Denominator = 1;
	sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
	sd.OutputWindow = g_hWindow;
	sd.SampleDesc.Count = 1;
	sd.SampleDesc.Quality = 0;
	sd.Windowed = TRUE;
	sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;

	// @\x̐ݒ
	//  v鏇Ԃɕׂ.
	D3D_FEATURE_LEVEL featureLevels[] = {
		D3D_FEATURE_LEVEL_11_0, D3D_FEATURE_LEVEL_10_0, D3D_FEATURE_LEVEL_9_3,
	};
	UINT nLevelCount = sizeof( featureLevels ) / sizeof( featureLevels[0] );


	D3D_FEATURE_LEVEL supportLevel; // foCXɑIꂽ@\x.
	ID3D11Device*	  pd3dDevice = 0;   
	IDXGISwapChain*   pSwapChain = 0;
	ID3D11DeviceContext*	pImmediateContext = 0;

	// foCX̍쐬.
	HRESULT hr = D3D11CreateDeviceAndSwapChain( 
				NULL, 
				D3D_DRIVER_TYPE_HARDWARE, 
				NULL, 
				D3D11_CREATE_DEVICE_DEBUG, 
				featureLevels, 
				nLevelCount, 
				D3D11_SDK_VERSION, 
				&sd, 
				&pSwapChain, 
				&pd3dDevice, 
				&supportLevel,
				&pImmediateContext );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "D3D11CreateDeviceAndSwapChain failed.\n" );
	}


	// obNobt@̏
	ID3D11Texture2D*	pBackBuffer = 0;
	ID3D11RenderTargetView*	pRenderTargetView = 0;
	hr = pSwapChain->GetBuffer( 0, __uuidof(ID3D11Texture2D), (void**)&pBackBuffer );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "GetBufferŎs.\n" );
	}
	hr = pd3dDevice->CreateRenderTargetView( pBackBuffer, NULL, &pRenderTargetView );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "CreateRenderTargetView [Backbuffer] failed.\n" );
	}
	if( pBackBuffer )
	{	// obNobt@͂gȂ̂ŉ.
		pBackBuffer->Release();
		pBackBuffer = 0;
	}
	// obNobt@pɃfvXEXeV̏
	D3D11_TEXTURE2D_DESC descDepth;
	ZeroMemory( &descDepth, sizeof(descDepth) );
	descDepth.Width = 640; descDepth.Height = 480;
	descDepth.MipLevels = 1;
	descDepth.ArraySize = 1;
	descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
	descDepth.SampleDesc.Count = 1; descDepth.SampleDesc.Quality = 0;
	descDepth.Usage = D3D11_USAGE_DEFAULT;
	descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;

	ID3D11Texture2D* pDepthStencil = 0;
	hr = pd3dDevice->CreateTexture2D( &descDepth, NULL, &pDepthStencil );

	D3D11_DEPTH_STENCIL_VIEW_DESC descDepthStencilView;
	ZeroMemory( &descDepthStencilView, sizeof(descDepthStencilView) );
	descDepthStencilView.Format = descDepth.Format;
	descDepthStencilView.ViewDimension =  D3D11_DSV_DIMENSION_TEXTURE2D;
	descDepthStencilView.Texture2D.MipSlice = 0;

	ID3D11DepthStencilView* pDepthStencilView = 0;
	hr = pd3dDevice->CreateDepthStencilView( pDepthStencil, &descDepthStencilView, &pDepthStencilView );

	if( pDepthStencil )
	{
		pDepthStencil->Release();
		pDepthStencil = 0;
	}

	// 쐬er[`^[Qbgɐݒ.
	pImmediateContext->OMSetRenderTargets( 1, &pRenderTargetView, pDepthStencilView );

	createResourcePrimaryDraw( pd3dDevice );
	createResourceRenderTargetDraw( pd3dDevice );

	g_Resource[0].pRTV = pRenderTargetView; pRenderTargetView->AddRef();
	g_Resource[0].pDSV = pDepthStencilView; pDepthStencilView->AddRef();

	UINT SampleCount = 4;
	UINT Quality = 0;
	pd3dDevice->CheckMultisampleQualityLevels( DXGI_FORMAT_R8G8B8A8_UNORM, SampleCount, &Quality );
	Quality -= 1;

	// eNX`̏
	ID3D11Texture2D* pRenderTexture = NULL;
	ID3D11Texture2D* pResolveTexture = NULL;
	D3D11_TEXTURE2D_DESC descTex;
	ZeroMemory( &descTex, sizeof(descTex) );
	descTex.ArraySize = 1;
	descTex.BindFlags = D3D11_BIND_RENDER_TARGET | D3D11_BIND_SHADER_RESOURCE;
	descTex.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	descTex.Width = 256;
	descTex.Height= 256;
	descTex.Usage = D3D11_USAGE_DEFAULT;
	descTex.SampleDesc.Count = SampleCount;
	descTex.SampleDesc.Quality = Quality;
	descTex.MipLevels = 1;
	hr = pd3dDevice->CreateTexture2D( &descTex, NULL, &pRenderTexture );
	ID3D11ShaderResourceView* pRenderTextureSRV = NULL;

	pd3dDevice->CreateRenderTargetView( pRenderTexture, NULL, &(g_Resource[1].pRTV) );
	ID3D11Texture2D* pRenderTextureDepth = NULL;
	descTex.BindFlags = D3D11_BIND_DEPTH_STENCIL;
	descTex.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
	hr = pd3dDevice->CreateTexture2D( &descTex, NULL, &pRenderTextureDepth );
	hr = pd3dDevice->CreateDepthStencilView( pRenderTextureDepth, NULL, &(g_Resource[1].pDSV) );
	if( pRenderTextureDepth ) {
		pRenderTextureDepth->Release();pRenderTextureDepth = 0;
	}

	descTex.BindFlags = D3D11_BIND_SHADER_RESOURCE;
	descTex.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	descTex.SampleDesc.Count = 1;
	descTex.SampleDesc.Quality = 0;
	pd3dDevice->CreateTexture2D( &descTex, NULL, &pResolveTexture );
	pd3dDevice->CreateShaderResourceView( pResolveTexture, NULL, &pRenderTextureSRV );

	// Tv[̐ݒIuWFNg
	ID3D11SamplerState* pSamplerState = 0;
	D3D11_SAMPLER_DESC  descSamp;
	ZeroMemory( &descSamp, sizeof(descSamp) );
	descSamp.AddressU = D3D11_TEXTURE_ADDRESS_CLAMP;
	descSamp.AddressV = D3D11_TEXTURE_ADDRESS_CLAMP;
	descSamp.AddressW = D3D11_TEXTURE_ADDRESS_CLAMP;
	descSamp.MaxAnisotropy = 1;
	descSamp.Filter = D3D11_FILTER_MIN_MAG_MIP_POINT;
	descSamp.ComparisonFunc = D3D11_COMPARISON_NEVER;
	descSamp.MaxLOD = D3D11_FLOAT32_MAX;
	pd3dDevice->CreateSamplerState( &descSamp, &pSamplerState );
	pImmediateContext->PSSetSamplers( 0, 1, &pSamplerState );

	ID3D11Buffer* pConstant = 0;
	D3D11_BUFFER_DESC descCB;
	ZeroMemory( &descCB, sizeof(descCB));
	descCB.ByteWidth = 1024;
	descCB.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
	descCB.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
	descCB.Usage = D3D11_USAGE_DYNAMIC;
	pd3dDevice->CreateBuffer( &descCB, NULL, &pConstant );

	// C bZ[W [v:
	do {
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else {
			XMMATRIX mat1 = XMMatrixOrthographicRH( 256, 480, 0.1f, 100.0f );
			drawToTexture( pImmediateContext );

			// Resolve
			pImmediateContext->ResolveSubresource( pResolveTexture, 0, pRenderTexture, 0, DXGI_FORMAT_R8G8B8A8_UNORM );

			XMMATRIX mat2 = XMMatrixMultiply( XMMatrixLookAtRH( XMVectorSet(0,0,10,0),  XMVectorZero(), XMVectorSet(0.0, 1.0f,0.0, 0) ),
				XMMatrixOrthographicRH( 640, 480, 0.1f, 100.0f ) );
			D3D11_MAPPED_SUBRESOURCE p;
			hr = pImmediateContext->Map( pConstant, 0, D3D11_MAP_WRITE_DISCARD, 0, &p );
			if( SUCCEEDED(hr) ) {
				memcpy( p.pData, &mat2, sizeof(mat2) );
				pImmediateContext->Unmap( pConstant, 0 );
			}
			pImmediateContext->VSSetConstantBuffers( 0, 1, &pConstant );
			drawToPrimary( pImmediateContext, pRenderTextureSRV );
			pSwapChain->Present( 0, 0 );
		}
	} while( msg.message != WM_QUIT );

	if( pImmediateContext )
	{	// foCX̃Xe[gԂɖ߂B
		pImmediateContext->ClearState();
	}
	deleteResource();

	if( pConstant ) { pConstant->Release(); pConstant = 0; }
	if( pRenderTexture ) { pRenderTexture->Release(); pRenderTexture = 0; }
	if( pRenderTextureDepth ) { pRenderTextureDepth->Release(); pRenderTextureDepth = 0; }
	if( pRenderTextureSRV ) { pRenderTextureSRV->Release(); pRenderTextureSRV = 0; }
	if( pResolveTexture ) { pResolveTexture->Release(); pResolveTexture = 0; }
	if( pSamplerState ) { pSamplerState->Release(); pSamplerState = 0; }
	if( pRenderTargetView ) { pRenderTargetView->Release(); pRenderTargetView = 0; }
	if( pDepthStencilView ) { pDepthStencilView->Release(); pDepthStencilView = 0; }
	if( pImmediateContext ) { pImmediateContext->Release(); pImmediateContext = 0; }
	if( pd3dDevice ) { pd3dDevice->Release(); pd3dDevice = 0; }
	if( pSwapChain ) { pSwapChain->Release(); pSwapChain = 0; }


	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   RECT rc = { 0, 0, 640, 480 };
   AdjustWindowRect( &rc, WS_OVERLAPPEDWINDOW, FALSE );
   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
	   CW_USEDEFAULT, 0, rc.right - rc.left, rc.bottom - rc.top, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   g_hWindow = hWnd;
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
